; Assemble with PathToMasm32\ml" /c det32.asm
.686
.XMM

    .MODEL FLAT, C
    option casemap:none

_MM_SHUFFLE MACRO fp3, fp2, fp1, fp0
	exitm <( ( ( fp3 ) shl 6)  or  ( ( fp2 ) shl 4 )  or  ( ( fp1 ) shl 2 ) or  ( ( fp0 ) ) ) >
ENDM

_PERMUTE_PS MACRO v, c
	shufps v, v, c
ENDM

_VECTORSWIZZLE MACRO v, fp0, fp1, fp2, fp3
	_PERMUTE_PS v, _MM_SHUFFLE (fp3, fp2, fp1, fp0)
ENDM

T4x4MATRIX struct 16
	r0 XMMWORD ?
	r1 XMMWORD ?
	r2 XMMWORD ?
	r3 XMMWORD ?
T4x4MATRIX ends

TFLOAT3X3 struct 4
	r0 REAL4 3 dup (?)
	r1 REAL4 3 dup (?)
	r2 REAL4 3 dup (?)
TFLOAT3X3 ends

_REALSTOXMM MACRO par1, par2, par3, par4
Local xmmValue
  .const
  align 16
  xmmValue dd par1, par2, par3, par4
  .code
  exitm <xmmValue>
ENDM	

HANDLE TYPEDEF PTR
HeapAlloc proto STDCALL :HANDLE, : DWORD, :DWORD
HeapFree proto STDCALL :HANDLE, : DWORD, : PTR
GetProcessHeap proto STDCALL

.const
_MINUSONE REAL4 -1.0
_PLUSONE REAL4 1.0
_REALZERO REAL4 0.0

.code

DeterminantWorker proc public uses ebx esi edi inMat : ptr, rows : dword
	LOCAL savedP0 : XMMWORD
	LOCAL savedP1 : XMMWORD
	LOCAL savedP2 : XMMWORD
	LOCAL heapPtr : ptr 
	LOCAL det : REAL4
	LOCAL sign : REAL4
	LOCAL midLoopCounter : DWORD
	LOCAL minorColIdx : dword
	LOCAL origRowIdx : dword
	LOCAL minorRowIdx : dword
	LOCAL outerIdx : dword

	mov esi, inMat
	mov eax, _REALZERO
	mov det, eax
	mov eax, _PLUSONE 
	mov sign, eax 

	.if rows==4 ; All 4x4 Matrixes and 4x4 Minors
		mov ecx, inMat
		ASSUME ecx : ptr T4x4MATRIX
		movups xmm6, [ecx].r2 
		movups xmm1, [ecx].r3
		movaps xmm2, xmm6
		_VECTORSWIZZLE xmm2, 1, 0, 0, 0
		movaps xmm3, xmm1
		_VECTORSWIZZLE xmm3, 2, 2, 1, 1
		movaps xmm4, xmm6
		_VECTORSWIZZLE xmm4, 1, 0, 0, 0
		movaps xmm5, xmm1
		_VECTORSWIZZLE xmm5, 3, 3, 3, 2
		movaps xmm0, xmm6
		_VECTORSWIZZLE xmm0, 2, 2, 1, 1
		movaps xmm7, xmm1
		_VECTORSWIZZLE xmm7, 3, 3, 3, 2

		mulps xmm2, xmm3 
		movups savedP0, xmm2
		mulps xmm4, xmm5
		movups savedP1, xmm4
		mulps xmm0, xmm7
		movups savedP2, xmm0
	
		movaps xmm2, xmm6
		_VECTORSWIZZLE xmm2, 2, 2, 1, 1
		movaps xmm3, xmm1
		_VECTORSWIZZLE xmm3, 1, 0, 0, 0
		movaps xmm4, xmm6
		_VECTORSWIZZLE xmm4, 3, 3, 3, 2
		movaps xmm5, xmm1
		_VECTORSWIZZLE xmm5, 1, 0, 0, 0
		movaps xmm0, xmm6
		_VECTORSWIZZLE xmm0, 3, 3, 3, 2
		movaps xmm7, xmm1
		_VECTORSWIZZLE xmm7, 2, 2, 1, 1

		mulps xmm2, xmm3
		movups xmm3, savedP0
		subps xmm3, xmm2
		movups XMMWORD ptr savedP0, xmm3
	;
		mulps xmm4, xmm5
		movups xmm5, XMMWORD ptr savedP1		
		subps xmm5, xmm4

		mulps xmm0, xmm7
		movups xmm7, XMMWORD ptr savedP2
		subps xmm7, xmm0

		movups xmm6, [ecx].r1
		movaps xmm2, xmm6
		_VECTORSWIZZLE xmm2, 3, 3, 3, 2
		movaps xmm3, xmm6
		_VECTORSWIZZLE xmm3, 2, 2, 1, 1
		movaps xmm4, xmm6
		_VECTORSWIZZLE xmm4, 1, 0, 0, 0
	
		movups xmm0, [ecx].r0
		mulps xmm0, XMMWORD ptr _REALSTOXMM(1.0, -1.0, 1.0, -1.0)
		movups xmm1, XMMWORD ptr savedP0
		mulps xmm2, xmm1
	
		mulps xmm3, xmm5 
		subps xmm2, xmm3
	
		mulps xmm4, xmm7
		addps xmm4, xmm2
	
		mulps xmm0, xmm4
		shufps xmm4, xmm0, _MM_SHUFFLE(1,0,0,0)
		addps xmm4, xmm0
		shufps xmm0, xmm4, _MM_SHUFFLE(0,3,0,0)
		addps xmm0, xmm4
		_PERMUTE_PS xmm0, _MM_SHUFFLE(2,2,2,2)

		ASSUME ecx : nothing
	.elseif rows==3 ; Only used for 3x3 matrixes
		ASSUME ecx : ptr TFLOAT3X3
		mov ecx, inMat
		movups xmm3, XMMWORD ptr [ecx].r0
		mulps xmm3, XMMWORD ptr _REALSTOXMM (1.0,-1.0,1.0,1.0)

		movups xmm0, XMMWORD ptr [ecx].r1+4
		movq xmm2, qword ptr [ecx].r2+4
		shufps xmm0, xmm2, _MM_SHUFFLE(1,0,1,0)
		;calculate first determinant
		shufps xmm1, xmm0, _MM_SHUFFLE(0,1,0,0)
		mulps xmm0, xmm1
		shufps xmm1, xmm0, _MM_SHUFFLE(2,0,0,0)
		shufps xmm0, xmm0, _MM_SHUFFLE(3,3,3,3)
		shufps xmm1, xmm1, _MM_SHUFFLE(3,3,3,3)
		subps xmm0, xmm1
		movaps xmm4, xmm0
	
		movups xmm0, XMMWORD ptr [ecx].r1
		movups xmm2, XMMWORD ptr [ecx].r1+8 
		shufps xmm0, xmm2, _MM_SHUFFLE(3,1,2,0)
		;calculate second determinant
		shufps xmm1, xmm0, _MM_SHUFFLE(0,1,0,0)
		mulps xmm0, xmm1
		shufps xmm1, xmm0, _MM_SHUFFLE(2,0,0,0)
		shufps xmm0, xmm0, _MM_SHUFFLE(3,3,3,3)
		shufps xmm1, xmm1, _MM_SHUFFLE(3,3,3,3)
		subps xmm0, xmm1
		movaps xmm5, xmm0
	
		movups xmm0, XMMWORD ptr [ecx].r1
		movq xmm2, qword ptr [ecx].r2
		shufps xmm0, xmm2, _MM_SHUFFLE(1,0,1,0)
		;calculate third determinant
		shufps xmm1, xmm0, _MM_SHUFFLE(0,1,0,0)
		mulps xmm0, xmm1
		shufps xmm1, xmm0, _MM_SHUFFLE(2,0,0,0)
		shufps xmm0, xmm0, _MM_SHUFFLE(3,3,3,3)
		shufps xmm1, xmm1, _MM_SHUFFLE(3,3,3,3)
		subps xmm0, xmm1

		unpckhps xmm4, xmm5
		shufps xmm4, xmm0, _MM_SHUFFLE(0,0,1,0)
		mulps xmm3, xmm4
	
		movaps xmm0, xmm3
		movhlps xmm0, xmm0
		addps xmm0, xmm3
		shufps xmm3, xmm3, 1
		addss xmm0, xmm3
		shufps xmm0, xmm0,0 
		ASSUME ecx : nothing		
	.elseif rows==2 ; Only used for 2x2 matrixes
		mov ecx, inMat
		movss xmm0, dword ptr [ecx+12]
		movss xmm1, dword ptr [ecx+8]
		mulss xmm0, dword ptr [ecx]
		mulss xmm1, dword ptr [ecx+4]
		subss xmm0, xmm1
	.else
		INVOKE GetProcessHeap
		mov heapPtr, eax  
		mov eax, rows
		dec eax
		mul eax
		shl eax, 2
		INVOKE HeapAlloc, heapPtr, 0, eax ; space for new (n-1)x(n-1) matrix
		mov edi, eax		
		mov ebx,0
		mov outerIdx,0
		
		.while ebx<rows
			mov outerIdx, ebx
			mov midLoopCounter, 1
			mov edx, 1
		
			.while edx<rows
				mov minorColIdx,0
				
				mov eax, rows
				add origRowIdx, eax
				mov ecx, midLoopCounter
				mul ecx
				mov origRowIdx, eax
				mov eax, rows

				lea eax,[4*eax-4]
				sub ecx, 1
				mul ecx
				
				mov minorRowIdx, eax
				mov edx,0
				.while edx<rows
					.if outerIdx != edx
						lea ecx, [4*edx]
						mov eax, origRowIdx 
						lea eax,[4*eax+ecx]
						mov ebx, REAL4 ptr [esi+eax]
						mov eax, minorRowIdx
						mov ecx, minorColIdx
						lea eax, [eax+4*ecx]
						mov REAL4 ptr [edi+eax], ebx
						add minorColIdx, 1
					.endif
					add edx,1
				.endw
				
				add midLoopCounter,1
				mov edx, midLoopCounter
			.endw
			mov edx,  rows
			sub edx,1
			INVOKE DeterminantWorker, edi, edx
			mov ebx, outerIdx
			movss xmm1, dword ptr [esi+4*ebx]
			mulss xmm1, sign
			mulss xmm0, xmm1	
			
			movss xmm2, det
			addss xmm0, xmm2
			movss det, xmm0
			
			movss xmm1, sign
			mulss xmm1, _MINUSONE
			movd sign, xmm1
			
			add ebx,1
		.endw
		INVOKE HeapFree, heapPtr, 0, edi
		movss xmm0, det
	.endif
	ret
DeterminantWorker endp

Determinant proc public inMat : ptr, rows : dword
	LOCAL Result : REAL4
	INVOKE DeterminantWorker, inMat, rows
	movss Result, xmm0
	fld Result
	ret
Determinant endp

end

